﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;

namespace BusinessLibrary
{
   public class Person : INotifyPropertyChanged
   {
      public Person()
      {

      }

      public Person(string firstName, string lastName)
      {
         this.FirstName = firstName;
         this.LastName = lastName;
      }

      private string _firstName;
      public string FirstName
      {
         get
         {
            return _firstName;
         }
         set
         {
            _firstName = value;
            OnPropertyChanged("FirstName");
            OnPropertyChanged("FullName");
         }
      }

      private string _lastName;
      public string LastName
      {
         get
         {
            return _lastName;
         }
         set
         {
            _lastName = value;
            OnPropertyChanged("LastName");
            OnPropertyChanged("FullName");
         }
      }

      public string FullName
      {
         get
         {
            return string.Format("{0} {1}", this.FirstName, this.LastName);
         }
      }

      #region INotifyPropertyChanged Members

      public event PropertyChangedEventHandler PropertyChanged;
      private void OnPropertyChanged(string propertyName)
      {
         if (this.PropertyChanged != null)
         {
            this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
         }
      }

      #endregion
   }
}
